import { quotePatterns } from "./regexFactory";
import { Token } from "./token";
export interface IdentChars {
    first?: string;
    rest?: string;
    dashes?: boolean;
    allowFirstCharNumber?: boolean;
}
export declare type PlainQuoteType = keyof typeof quotePatterns;
export interface PrefixedQuoteType {
    quote: PlainQuoteType;
    prefixes: string[];
    requirePrefix?: boolean;
}
export declare type QuoteType = PlainQuoteType | PrefixedQuoteType;
export interface VariableRegex {
    regex: string;
}
export declare type VariableType = VariableRegex | PrefixedQuoteType;
export interface ParamTypes {
    positional?: boolean;
    numbered?: ('?' | ':' | '$')[];
    named?: (':' | '@' | '$')[];
    quoted?: (':' | '@' | '$')[];
}
export interface TokenizerOptions {
    reservedCommands: string[];
    reservedSelect: string[];
    supportsXor?: boolean;
    reservedSetOperations: string[];
    reservedJoins: string[];
    reservedPhrases?: string[];
    reservedFunctionNames: string[];
    reservedKeywords: string[];
    stringTypes: QuoteType[];
    identTypes: QuoteType[];
    variableTypes?: VariableType[];
    extraParens?: ('[]' | '{}')[];
    paramTypes?: ParamTypes;
    lineCommentTypes?: string[];
    nestedBlockComments?: boolean;
    identChars?: IdentChars;
    paramChars?: IdentChars;
    operators?: string[];
    postProcess?: (tokens: Token[]) => Token[];
}
